
#include <stdlib.mqh>


#property  indicator_chart_window

extern   double            DaysBack       = 40;
         double            idxLow,idxHigh,day;
         int            candles,prevCandle,bar;
         double         DigitsMulti,adj;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
      Comment("");
      if (Digits==3||Digits == 5) DigitsMulti = 10;else DigitsMulti=1;
      adj=DigitsMulti*Point;
      
      ////////  GET SETTINGS FOR BROKER  ////////
      Print("lotsize ",MarketInfo(Symbol(),MODE_LOTSIZE));
      Print("lotstep ",MarketInfo(Symbol(),MODE_LOTSTEP));
      Print("minlot ",MarketInfo(Symbol(),MODE_MINLOT));
      Print("maxlot ",MarketInfo(Symbol(),MODE_MAXLOT));
      Print("stoplevel ",MarketInfo(Symbol(),MODE_STOPLEVEL));   
      ///////////////////////////////////////////
      for(int i=0;i<10000;i++)
      {
         ObjectDelete("hi"+i);
         ObjectDelete("lo"+i);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      for(int i=0;i<10000;i++)
      {
         ObjectDelete("hi"+i);
         ObjectDelete("lo"+i);
      }
   Comment("");
//----
   return(0);
  }
  
int start() 
   {   
      //if(bar!=Bars)
      {
         day=0;
         candles=0;
         while(day<DaysBack)
         {
            candles++;
            if(TimeDayOfWeek(Time[candles])!=6 && TimeDayOfYear(Time[candles])!=TimeDayOfYear(Time[prevCandle]))day++;
            prevCandle=candles;
            
         }
         //candles--;
         double lows,highs,totLow,totHigh,avgLow,avgHigh,tp,avgHiLo,tp2;
         for(int i=candles;i>=0;i--)
         {
            if(TimeDayOfWeek(Time[i])!=6)
            {
            
               if(Low[i]!=0 && Low[i+1]!=0 && Low[i]<Low[i+1])
               {
                  totLow+=Low[i+1]-Low[i];lows++;
            
                  ObjectCreate("lo"+i,OBJ_TEXT,0,0,0);
                  ObjectSetText("lo"+i,DoubleToStr((Low[i+1]-Low[i])/adj,1)+"       ",7,"",Gray);
                  ObjectSet("lo"+i,OBJPROP_ANGLE,90);
                  ObjectMove("lo"+i,0,Time[i],Low[i]);
               
               
                  }
         
               if(High[i]!=0 && High[i+1]!=0 && High[i]>High[i+1])
               {
                  totHigh+=High[i]-High[i+1];highs++;
            
                  ObjectCreate("hi"+i,OBJ_TEXT,0,0,0);
                  ObjectSetText("hi"+i,"       "+DoubleToStr((High[i]-High[i+1])/adj,1),7,"",Gray);
                  ObjectSet("hi"+i,OBJPROP_ANGLE,90);
                  ObjectMove("hi"+i,0,Time[i],High[i]);
               }
            }
         }
         avgHiLo=(totLow+totHigh)/(lows+highs);
          
         Comment(
            "\ntotLow "+DoubleToStr(totLow/adj,1)+" number of lows "+DoubleToStr(lows,1)
            +"\ntotHigh "+DoubleToStr(totHigh/adj,1)+" number of highs "+DoubleToStr(highs,1)
            +"\nnumber of candles in "+DoubleToStr(DaysBack,1)+" days "+candles
            +"\nTakeProfit: "+DoubleToStr(NormalizeDouble(avgHiLo,Digits)/adj,1)
            +"\nATR-15M("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_M15,DaysBack*4*24,0)/adj,1)
            +"\nATR-H1("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_H1,DaysBack*24,0)/adj,1)
            +"\nATR-H4("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_H4,DaysBack*6,0)/adj,1)
            +"\nATR-D1("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_D1,DaysBack,0)/adj,1)
         );
         
       /* */
         bar=Bars;
      }
      return;
   }
            
            
            
//+------------------------------------------------------------------+
//| Creates the array of pair symbols to check                       |
//+------------------------------------------------------------------+  

